function [centers,gaps]=affinescaling(A,b,c,x0,beta)

n=length(x0);

m=size(A,1);

Am=[A,eye(m)];
c=[c;zeros(m,1)];

epsilon=0.01;
t=1;



centers{1}=[x0;b-A*x0]

gaps(1)=100;

while t<100,
    %det(D)
    X=diag(centers{t});
    mu{t}=inv(Am*X^2*Am')*Am*X^2*c;
    r{t}=c-Am'*mu{t};
    y=(centers{t}.^2).*r{t};
    ny=norm(centers{t}.*r{t});
    gaps(t)=sum(centers{t}.*r{t});
    rpos=(r{t}>=-10^-5);
    rpos=rpos+1-1;

    yneg=(y<=0);
    yneg=yneg+1-1;
    if prod(rpos)==1 && gaps(t)<epsilon,
        break;
    elseif prod(yneg)==1,
        break;
    end
    centers{t+1}=centers{t}-beta*y/ny;
    t=t+1;
end
