addpath(genpath('../'));
n=10;

user_entry=[];
f = [1; 1; 1];

while length(user_entry)==0,
    % Generating the example parameters A,b.
    A=rand(n,3); A=diag(1./sum(A,2))*A;
    b=2+rand(n,1);

    % Plotting Everything
    figure(1);
    clf;
    % Plotregion plots Ax>= b, we want the opposite so multiply by -1, and
    % add that the variable are lower bounded.
    A=-A;
    b=-b;

    plotregion(A,b,zeros(3,1),[],'b',.2);
    % add the arrow for the objective.
    arrow(zeros(3,1),f);
    axis tight;
    user_entry=input('Keep example?','s');

end

AA=A;
bb=b;

beta=.65
[centers,gaps]=affinescalinggamma(-A,-b,-f,[0.5;0.5;0.5],.5);

maxallcenter=3;
allcenters=[];

for i=1:length(centers),
    x=centers{i};
    allcenters=[allcenters,x(1:3,1)];
    %if length(allcenters)>maxallcenter,
    %    allcenters=allcenters(:,end-maxallcenter+1:end);
    %end
    [az,el] = view;
    figure(1);
    clf;
    hold on;
    plotregion(AA,bb,zeros(3,1),[],'b',.05,allcenters,'-ok','dbxr');

    %Ellipse_plot(inv(beta*(diag(x(1:3))))^2,x(1:3));
    view(az,el);
    axis tight;
    arrow(zeros(3,1),f);
    title(['---- ',num2str(gaps(i)),' ----']);
    pause();
end
