addpath(genpath('../'));
n=10;

user_entry=[];
f = [1; 1; 1];

while length(user_entry)==0,
    % Generating the example parameters A,b.
    A=(2*rand(n,3)-1);
    A=diag(1./sum(abs(A),2))*A;
    b=.01+rand(n,1)+sum(A,2);
    % Plotting Everything
    figure(1);
    clf;
    % Plotregion plots Ax>= b, we want the opposite so multiply by -1, and
    % add that the variable are lower bounded.
    A=-A;
    b=-b;

    plotregion(A,b,zeros(3,1),[],'b',.2);
    % add the arrow for the objective.
    arrow(zeros(3,1),f);
    axis tight;
    user_entry=input('Keep example?','s');

end

AA=A;
bb=b;

allcenters=[];
R0=25;
[matrices,centers,hyperplanes,emptyornot]=ellipsoidfeasibility(A,b,10^-10,R0*eye(3),zeros(3,1));

maxallcenter=4;
CONTINUE=1;
j=0;
while CONTINUE,
    j=j+1;
    for i=1:length(centers),
        allcenters=[allcenters,centers{i}];
        if length(allcenters)>maxallcenter,
            allcenters=allcenters(:,end-maxallcenter+1:end);
        end
        [az,el] = view;
        figure(1);
        clf;
        hold on;
        plotregion(AA,bb,zeros(3,1),[],'b',.2,allcenters,'-ok','dbxr');

        %if i<=length(hyperplanes),
        %    T=hyperplanes{i};
        %    plotregion([T(1:3)';-T(1:3)'],[T(end),0.000001-T(end)],[],[],'g',.1);
        %    %drawPlane(T(1:3)',T(end),'g');
        %end
        if j>1,
            plotregion(A,b,zeros(3,1),[],'r',.2);
        end
        eig(matrices{i})
        Ellipse_plot(inv(matrices{i}),centers{i});
        view(az,el);
        axis tight;
        VOL=num2str(pi^(n/2)/GAMMA(n/2+1)*det(matrices{i}));
        arrow(zeros(3,1),f);
        if i==length(centers),
            title(['---- ',VOL,'-- inside!']);
        else
            title(['---- ',VOL,' ----']);
        end
        pause();
        if VOL<10^-8,
            CONTINUE=0;
            break;
        end
    end
    if CONTINUE,
        currmat=matrices{length(matrices)};
        currcent=centers{length(centers)};
        A=[A;f'];
        b=[b;dot(f,currcent)+10^-7];
        [matrices,centers,hyperplanes,emptyornot]=ellipsoidfeasibility(A,b,10^-8,currmat,currcent);
    end
end
